package DataOneLdap;

use Net::LDAP;
use strict;
use Carp;
use IO::Prompt;

my $ldap;
my %hostname_ip_xref=( '128.111.36.78' => 'cn-dev-ucsb-1.test.dataone.org',
'160.36.13.153' => 'cn-dev-orc-1.test.dataone.org',
'64.106.40.9' => 'cn-dev-unm-1.test.dataone.org',
'128.111.54.83' => 'cn-dev-ucsb-2.test.dataone.org',
'64.106.40.24' => 'cn-dev-unm-2.test.dataone.org',
'128.111.36.77' => 'cn-sandbox-ucsb-1.test.dataone.org',
'160.36.13.152' => 'cn-sandbox-orc-1.test.dataone.org',
'64.106.40.7' => 'cn-sandbox-unm-1.test.dataone.org',
'128.111.36.76' => 'cn-stage-ucsb-1.test.dataone.org',
'160.36.13.151' => 'cn-stage-orc-1.test.dataone.org',
'64.106.40.8' => 'cn-stage-unm-1.test.dataone.org',
'160.36.13.141' => 'cn-stage-orc-2.test.dataone.org',
'129.237.201.86' => 'cn-stage-unm-2.test.dataone.org',
'192.168.131.10' => 'cn-cat-1.mock.dataone.org',
'192.168.131.12' => 'cn-cat-2.mock.dataone.org',
'192.168.131.14' => 'cn-cat-3.mock.dataone.org',
'129.237.201.86' => 'cn-stage-unm-2.test.dataone.org',
'128.111.36.80' => 'cn-ucsb-1.dataone.org',
'160.36.13.150' => 'cn-orc-1.dataone.org',
'64.106.40.6' => 'cn-unm-1.dataone.org');

my $ip_address = "";

sub new 
	{
	my $class = shift;
	my $self = {@_};
	open(IFCONFIG, "/sbin/ifconfig -a |") || die "can't fork: $!";

	while (<IFCONFIG>)
		{
		my $line = $_;
        	if ($line =~ /inet\saddr\:((?:(?:[01]?\d?\d?|2[0-4]\d|25[0-5])\.?){4})/ )
			{
			my $possible_ip = $1;	
			if (defined($hostname_ip_xref{$possible_ip}))
				{
				$ip_address = $possible_ip;
				last;
				}
			}
		}
	close(IFCONFIG);

	bless($self, $class);
	return $self;
	}
 
sub connect 
	{
	my $self = shift;
	$ldap = Net::LDAP->new("localhost");
	my $ldap_repl_pem =  '/etc/dataone/client/certs/' . $hostname_ip_xref{$ip_address} . '.pem';
	my $ldap_repl_key =  '/etc/dataone/client/private/' . $hostname_ip_xref{$ip_address} . '.key';
	my $mesg;
	my $tls_type;
	if (-e $ldap_repl_pem &&  -e $ldap_repl_key)
		{
		$tls_type = "with auth";
		$mesg = $ldap->start_tls(verify => 'none',
			clientcert => $ldap_repl_pem,
			clientkey => $ldap_repl_key);
#			capath => '/etc/ssl/certs');
		}
	else 
		{
		$tls_type = "with no auth";
		$mesg = $ldap->start_tls(verify => 'none');
		}
	if ($mesg->is_error()) 
		{
		die("start_tls $tls_type died: " . $mesg->error_text ());
		
		}
        prompt(-p=>"Enter LDAP password: ", -e=>"*");
	my $password = $_;
#       the below is from a later version of IO:Prompt that is not available on 12.04
#	my $password = prompt("Enter LDAP password: ", -e => '*');
	my $mesg = $ldap->bind("cn=admin,dc=dataone,dc=org", password=>${password});
	if ($mesg->is_error()) 
		{
		die("ldap bind died: " . $mesg->error_text ());
		}
	return $ldap;
	}
sub disconnect
	{
	my $self = shift;
	$ldap->unbind;
	}

1;
